// bump.vert

attribute vec3 tangent;

varying vec3 light;
varying vec3 view;

void main()
{
  // ٥ȥȸ٥ȥ
  vec3 v = vec3(gl_ModelViewMatrix * gl_Vertex);
  vec3 l = gl_LightSource[0].position.xyz - v;
  
  // ˡ٥ȥ٥ȥ뤫֤ܶؤѴ
  vec3 n = normalize(gl_NormalMatrix * gl_Normal);
  vec3 t = normalize(gl_NormalMatrix * tangent);
  vec3 b = cross(n, t);
  
  vec3 temp;
  
  // ֤ܶˤ٥ȥ
  temp.x = dot(v, t);
  temp.y = dot(v, b);
  temp.z = dot(v, n);
  view = normalize(temp);

  // ֤ܶˤ٥ȥ
  temp.x = dot(l, t);
  temp.y = dot(l, b);
  temp.z = dot(l, n);
  light = normalize(temp);

  // ƥɸĺɸϤ
  gl_TexCoord[0] = gl_MultiTexCoord0;
  gl_Position = ftransform();
}
